#!/usr/local/bin/perl
#
# Doug's WWW Finger Gateway
# 10/94
#
# Silly little script to finger the argument.  Hey, it could be useful!
# It accepts the argument to finger as either the complete QUERY_STRING
# environment var, or under the keyword "dest".
# If no argument, the script produces a form to fill out.
#
# .plan files with HTML anchors and stuff in them will work, but they
# will be surrounded by <PRE> tags.  So a totally WWW-less person with
# a .plan can actually have a home page, sort of.
#
# Requires cgi-lib.pl which can be found at
#    http://www.bio.cam.ac.uk/web/form.html
#
# Doug Stevenson
# doug+@osu.edu

# location of your finger (no, not your hand)
$finger = '/usr/ucb/finger';


$SIG{'TERM'} = 'handler';
$SIG{'KILL'} = 'handler';
$SIG{'ALRM'} = 'handler';
alarm(180);                     # force exit in 3 minutes

sub handler {
    if ($xpid) {
        kill 9, $xpid;
    }
    exit(1);
}


require '/usr/local/WWW/cgi-bin/cgi-lib.pl';
&ReadParse();

# everything after the ? is what we want
$dest = $in{'dest'} ? $in{'dest'} : $ENV{'QUERY_STRING'};

#########################################################
# check for some loozer trying to run a different process
#########################################################

if ($dest =~ /;|>|`|\||&/) {
    print &PrintHeader();
    print <<EOH;
<HTML><HEAD><TITLE>Forget it, bum!</TITLE></HEAD>
<BODY><H1>Forget it, bum!</H1>
<P>Either you made a big typo, or you're trying something funny with
the system.  Try again.</P>
<A HREF="/cgi-bin/finger.pl">Back to Finger Gateway</A>
</BODY></HTML>
EOH
    exit(0);
}

##################
# spew source code
##################

if ($dest eq 'source') {
    open(SOURCE,'/usr/local/WWW/cgi-bin/finger.pl');
    print "Content-Type: text/plain\n\n";
    print <SOURCE>;
    close(SOURCE);
    exit(0);
}

####################################
# or give them a form if no argument
####################################

elsif ($dest eq '') {
    print &PrintHeader();
    print <<EOH;
<HTML><HEAD><TITLE>Doug\'s WWW Finger Gateway</TITLE></HEAD>
<BODY><H1>WWW Finger Gateway</H1>
<FORM ACTION="http://www-bprc.mps.ohio-state.edu/cgi-bin/finger.pl" METHOD=GET>
<P>Fill in the blank with the account/machine to finger.  If you\'re
just interested source, try <A HREF="http:/cgi-bin/finger.pl?source">here</A>.
</P>
<P><INPUT TYPE="submit" VALUE="Finger:"><INPUT SIZE=40 NAME="dest"></P>
<HR>
<ADDRESS><P><A HREF="http://www-bprc.mps.ohio-state.edu/~doug/">Doug Stevenson: doug+\@osu.edu</A>
</P></ADDRESS>
</BODY></HTML>
EOH
    exit(0);
}

elsif (!($dest =~ /^.+\@.+$/)) {
    print &PrintHeader();
    print <<EOH;
<HTML><HEAD><TITLE>WWW Finger Gateway: Error</TITLE></HEAD>
<BODY><H1>Error: Not a valid network address</H1>
<P>The address your entered, "<B>$dest</B>," is not valid.  Please
<A HREF="/cgi-bin/finger.pl">go back</A> and try again.</P>
EOH
    exit(0);
}

###############################################
# none of the above - got an argument to finger
###############################################

print "Content-Type: text/html\n\n";

print <<EOH;
<HTML><HEAD><TITLE>Doug\'s WWW Finger Gateway</TITLE></HEAD>
<BODY><H1>WWW Finger Gateway</H1>
<H2>Results of fingering $dest</H2><HR>
EOH
    ;

###############
# do the finger
###############

if ($xpid = open(FINGER,"$finger $dest |")) {
    print "<PRE>", <FINGER>, "</PRE>";
    close(FINGER);
}
else {
    print <<EOH;
<P>There was an error during the finger process.  Please notify
<A HREF="http://www-bprc.mps.ohio-state.edu/~doug/">Doug</A> right away!</P>
EOH
}

##############
# print footer
##############

print <<EOH;
<HR>
<P><A HREF="http://www-bprc.mps.ohio-state.edu/cgi-bin/finger.pl">WWW Finger Gateway</A> by <A HREF="http://www-bprc.mps.ohio-state.edu/~doug/">Doug Stevenson</A>
</BODY></HTML>
EOH
    ;

exit(0);


## end of finger.pl
